package SerialHeat;

import java.awt.Canvas;
import java.awt.Color;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.MouseMotionListener;
import java.awt.image.BufferedImage;
import java.awt.image.DataBufferInt;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JOptionPane;
import javax.swing.JTextField;

public class GUI extends Canvas implements MouseListener, MouseMotionListener  {
	private static JFrame frame;
	
	private static JButton runB, exitB, hotSpotB, insulatorB, heaterB, clearB; 
	private static JButton timeStepB, aboutB, brushUpB, brushDownB;
	private static JTextField timeStepBox;
	
	private static RunButtonHandler rHand;
	private static AddHotSpotButtonHandler ahsHand;
	private static AddHeaterButtonHandler ahHand;
	private static AddInsulatorButtonHandler aiHand;
	private static ExitButtonHandler eHand;
	private static ClearButtonHandler cHand;
	private static AboutButtonHandler aboutHand;
	private static BrushUpButtonHandler buHand;
	private static BrushDownButtonHandler bdHand;
	private static TimeStepButtonHandler tHand;
	
	public static BufferedImage pic;
	public static GUI g;
	static int timeSteps = 5000;
	static boolean heaterButtonActive = false;
	static boolean insulatorButtonActive = false;
	static boolean hotSpotButtonActive = false;
	static boolean firstClick = false;
	static boolean secondClick = false;
	static boolean running = false;
	static boolean released = false;
	static int cx,cy, rx, ry;
	
	public static void main(String[] args) {

		pic = new BufferedImage(DataArray.X,DataArray.Y,BufferedImage.TYPE_INT_RGB);
		//JFrame
		frame = new JFrame();
		frame.setTitle("Heat Diffusion Simluator");
				
		//text field
		timeStepBox = new JTextField("Time: 0/" +timeSteps,10);
		timeStepBox.setEditable(false);
				
		//buttons
		hotSpotB = new JButton("Add Hot Spot");
		ahsHand = new AddHotSpotButtonHandler();
		hotSpotB.addActionListener(ahsHand);
				
		heaterB = new JButton("Add Heater");
		ahHand = new AddHeaterButtonHandler();
		heaterB.addActionListener(ahHand);
		
		clearB = new JButton("Clear");
		cHand = new ClearButtonHandler();
		clearB.addActionListener(cHand);
				
		aboutB = new JButton("About");
		aboutHand = new AboutButtonHandler();
		aboutB.addActionListener(aboutHand);
				
		insulatorB = new JButton("Add Insulator");
		aiHand = new AddInsulatorButtonHandler();
		insulatorB.addActionListener(aiHand);
				
		runB = new JButton("Run");
		rHand = new RunButtonHandler();
		runB.addActionListener(rHand);
				
		brushUpB = new JButton("Brush +");
		buHand = new BrushUpButtonHandler();
		brushUpB.addActionListener(buHand);
				
		brushDownB = new JButton("Brush -");
		bdHand = new BrushDownButtonHandler();
		brushDownB.addActionListener(bdHand);
		
		timeStepB = new JButton("# Steps");
		tHand = new TimeStepButtonHandler();
		timeStepB.addActionListener(tHand);
				
		exitB = new JButton("Exit");
		eHand = new ExitButtonHandler();
		exitB.addActionListener(eHand);
				
		//grab Content Pane
		Container pane = frame.getContentPane();
		pane.setLayout(new GridBagLayout());
				
		//image constraints
		GridBagConstraints ic = new GridBagConstraints();
		ic.anchor= GridBagConstraints.NORTHWEST;
		ic.gridwidth = GridBagConstraints.REMAINDER;
		ic.gridheight = 6;
		ic.gridx =0;
		ic.gridy = 0;
				
		//timeStepBox constraints
		GridBagConstraints tsc = new GridBagConstraints();
		tsc.anchor= GridBagConstraints.CENTER;
		tsc.gridwidth = 1;
		tsc.gridheight = 1;
		tsc.gridx =10;
		tsc.gridy = 6;
				
		//hotspot button constraints
		GridBagConstraints hsc = new GridBagConstraints();
		hsc.anchor= GridBagConstraints.NORTHWEST;
		hsc.gridwidth = 1;
		hsc.gridheight = 1;
		hsc.gridx =0;
		hsc.gridy = 6;

		//heater button constraints
		GridBagConstraints hbc = new GridBagConstraints();
		hbc.anchor= GridBagConstraints.NORTHWEST;
		hbc.gridwidth = 1;
		hbc.gridheight = 1;
		hbc.gridx =1;
		hbc.gridy = 6;
		
		//insulator button constraints
		GridBagConstraints inc = new GridBagConstraints();
		inc.anchor= GridBagConstraints.NORTHWEST;
		inc.gridwidth = 1;
		inc.gridheight = 1;
		inc.gridx =2;
		inc.gridy = 6;
		
		//run button constraints
		GridBagConstraints rc = new GridBagConstraints();
		rc.anchor= GridBagConstraints.NORTHWEST;
		rc.gridwidth = 1;
		rc.gridheight = 1;
		rc.gridx =7;
		rc.gridy = 6;
		
		//clear button constraints
		GridBagConstraints cbc = new GridBagConstraints();
		cbc.anchor= GridBagConstraints.NORTHWEST;
		cbc.gridwidth = 1;
		cbc.gridheight = 1;
		cbc.gridx =5;
		cbc.gridy = 6;
		
		//about button constraints
		GridBagConstraints abc = new GridBagConstraints();
		abc.anchor= GridBagConstraints.NORTHWEST;
		abc.gridwidth = 1;
		abc.gridheight = 1;
		abc.gridx =8;
		abc.gridy = 6;
		
		//exit button constraints
		GridBagConstraints ec = new GridBagConstraints();
		ec.anchor= GridBagConstraints.NORTHWEST;
		ec.gridwidth = 1;
		ec.gridheight = 1;
		ec.gridx =9;
		ec.gridy = 6;
		
		//brush + button constraints
		GridBagConstraints buc = new GridBagConstraints();
		buc.anchor= GridBagConstraints.NORTHWEST;
		buc.gridwidth = 1;
		buc.gridheight = 1;
		buc.gridx =3;
		buc.gridy = 6;
				
		//brush - button constraints
		GridBagConstraints bdc = new GridBagConstraints();
		bdc.anchor= GridBagConstraints.NORTHWEST;
		bdc.gridwidth = 1;
		bdc.gridheight = 1;
		bdc.gridx =4;
		bdc.gridy = 6;
		
		//time button constraints
		GridBagConstraints tbc = new GridBagConstraints();
		tbc.anchor= GridBagConstraints.NORTHWEST;
		tbc.gridwidth = 1;
		tbc.gridheight = 1;
		tbc.gridx =6;
		tbc.gridy = 6;
				
		//add things to the pane
		DataArray d = new DataArray();
		g = new GUI();

		pane.add(g,ic);
		pane.add(hotSpotB,hsc);
		pane.add(heaterB,hbc);
		pane.add(insulatorB,inc);
		pane.add(runB,rc);
		pane.add(clearB,cbc);
		pane.add(brushUpB,buc);
		pane.add(brushDownB,bdc);
		pane.add(aboutB,abc);
		pane.add(exitB,ec);
		pane.add(timeStepB,tbc);
		pane.add(timeStepBox,tsc);
				
		//finalize JFrame
		frame.pack();
		frame.setVisible(true);
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		
		while (!running) {
			try {
				Thread.sleep(10);
			} catch (InterruptedException e) {
				e.printStackTrace();
			}
					
			while (heaterButtonActive) {
				try {
					Thread.sleep(10);
				} catch (InterruptedException e) {
					e.printStackTrace();
				}
				
			} 
			while (insulatorButtonActive) {
				try {
					Thread.sleep(10);
				} catch (InterruptedException e) {
					e.printStackTrace();
				}
				
			} 
			while (hotSpotButtonActive) {
				try {
					Thread.sleep(10);
				} catch (InterruptedException e) {
					e.printStackTrace();
				}		
			}
		}
	}
	
	public static void runSim() {
		long start = System.currentTimeMillis();
		if (heaterButtonActive) {
			heaterButtonActive = false;
			heaterB.setBackground(null);
			g.removeMouseListener(g);
			g.removeMouseMotionListener(g);
			g.validate();
			g.repaint();
		} else if (hotSpotButtonActive) {
			hotSpotButtonActive = false;
			hotSpotB.setBackground(null);
			g.removeMouseListener(g);
			g.removeMouseMotionListener(g);
			g.validate();
			g.repaint();
		} else if (insulatorButtonActive) {
			insulatorButtonActive = false;
			insulatorB.setBackground(null);
			g.removeMouseListener(g);
			g.removeMouseMotionListener(g);
			g.validate();
			g.repaint();
		}

		running = true;

		for (int i=0;i<timeSteps;i++) {
			timeStepBox.setText("Time: "+(i+1)+"/"+timeSteps);
			
			DataArray.diffuse();
			
			DataArray.currArr = DataArray.nextArr;
			DataArray.nextArr = new double[DataArray.X][DataArray.Y];
			
			g.validate();
			g.repaint();
			
		}
	        
		runB.setBackground(null);
		g.validate(); 
		g.repaint();
		System.out.println("Sim took " + (System.currentTimeMillis() - start));
	}
	
	
	@Override
	public Dimension getPreferredSize() {
	    return new Dimension(900, 600);
	}
	
	
	public void paint(Graphics g) {
		DataBufferInt buf = (DataBufferInt) pic.getRaster().getDataBuffer();
		int[] pixels = buf.getData();
		int[] colors = {0xFF0000,0xFF0033,0xFF0055,0xFF0099,0xFF00A6,0xFF00DD,0xFF00FB,0xE600FF,0xD400FF,0xBB00FF,0xAA00FF,0x9900FF,0x7300FF,0x5D00FF,0x4000FF};
		for (int y=0;y<DataArray.Y;y++) {
			for (int x=0;x<DataArray.X;x++) {
				double currElement = DataArray.currArr[x][y];
				int col;
				if (DataArray.isInsulator[x][y]) {
					col = 0x000000;
				} else if(DataArray.isRed[x][y]) {
					col = 0xFF0000;
					DataArray.isRed[x][y] = false;
				} else if(DataArray.isBlack[x][y]) {
					col = 0x000000;
					DataArray.isBlack[x][y] = false;
				}			
				else {
					if (currElement > 1000)
						currElement = 1000;
					col = colors[((1000-(int)currElement)/71)];
				}
				pixels[x+y*DataArray.X] = col;
			}
		}
		g.drawImage(pic,0,0,null);
    }
	
	public void update(Graphics g) {
		paint(g);
	}


	
	public static class RunButtonHandler implements ActionListener {
		public void actionPerformed(ActionEvent e) {
			try {
				runB.setBackground(Color.red);
				g.validate(); 
				g.repaint();
				 Thread r = new Thread()
	             {
	                public void run()
	                {
	                	runSim();
	                }
	             };
				
	             r.start();
			} catch(Exception exc) {
				
			}
		}
	}
	
	public static class AddHeaterButtonHandler implements ActionListener{
		public void actionPerformed(ActionEvent e) {
			try {
				if (!heaterButtonActive) {				
					heaterButtonActive = true;
					heaterB.setBackground(Color.red);
					if (insulatorButtonActive) {
						insulatorButtonActive = false;
						insulatorB.setBackground(null);
					}
					if (hotSpotButtonActive) {
						hotSpotButtonActive = false;
						hotSpotB.setBackground(null);
					}
					g.validate();
					g.repaint();
					g.addMouseListener(g);
					g.addMouseMotionListener(g);
				} else {
					heaterButtonActive = false;
					g.removeMouseListener(g);
					g.removeMouseMotionListener(g);
					heaterB.setBackground(null);
					g.validate();
					g.repaint();
				}
			} catch(Exception exc) {
				
			}
		}
	}
	
	
	public static class AddInsulatorButtonHandler implements ActionListener {
		public void actionPerformed(ActionEvent e) {
			try {
				if (!insulatorButtonActive) {				
					insulatorButtonActive = true;
					insulatorB.setBackground(Color.red);
					if (heaterButtonActive) {
						heaterButtonActive = false;
						heaterB.setBackground(null);
					}
					if (hotSpotButtonActive) {
						hotSpotButtonActive = false;
						hotSpotB.setBackground(null);
					}
					g.validate();
					g.repaint();
					g.addMouseListener(g);
					g.addMouseMotionListener(g);
				} else {
					insulatorButtonActive = false;
					g.removeMouseListener(g);
					g.removeMouseMotionListener(g);
					insulatorB.setBackground(null);
					g.validate();
					g.repaint();
				}
			} catch(Exception exc) {
				
			}
		}
	}
	
	public static class ClearButtonHandler implements ActionListener {
		public void actionPerformed(ActionEvent e) {
			try {
				DataArray.clear();
				g.validate();
				g.repaint();
			} catch(Exception exc) {
				
			}
		}
	}
	
	public static class TimeStepButtonHandler implements ActionListener {
		public void actionPerformed(ActionEvent e) {
			String str =JOptionPane.showInputDialog(frame, "Enter Number of Timesteps");
			try {		
				int steps = Integer.parseInt(str);
				timeSteps = steps;
				timeStepBox.setText("Timesteps: 0/" +timeSteps);
			} catch(Exception exc) {
				JOptionPane.showMessageDialog(frame,"Incorrect Input!\nPlease Enter An Integer.");
			}
		}
	}
	
	public static class AddHotSpotButtonHandler implements ActionListener {
		public void actionPerformed(ActionEvent e) {
			try {
				g.addMouseListener(g);
				if (!hotSpotButtonActive) {				
					hotSpotButtonActive = true;
					hotSpotB.setBackground(Color.red);
					if (insulatorButtonActive) {
						insulatorButtonActive = false;
						insulatorB.setBackground(null);
					}
					if (heaterButtonActive) {
						heaterButtonActive = false;
						heaterB.setBackground(null);
					}
					g.validate();
					g.repaint();
					g.addMouseListener(g);
					g.addMouseMotionListener(g);
				} else {
					hotSpotButtonActive = false;
					g.removeMouseListener(g);
					g.removeMouseMotionListener(g);
					hotSpotB.setBackground(null);
					g.validate();
					g.repaint();
				}
			} catch(Exception exc) {
				
			}
		}
	}
	
	public static class AboutButtonHandler implements ActionListener {
		public void actionPerformed(ActionEvent e) {
			JOptionPane.showMessageDialog(frame,"Heat Diffusion Simulator\n\nCreated by: Michael Graf and David Bunde\nA project to illustrate the the benefits of parallelism in Java.");
		}
	}
	
	public static class BrushUpButtonHandler implements ActionListener {
		public void actionPerformed(ActionEvent e) {
			try {
				DataArray.brushSize++;
			} catch(Exception exc) {
				
			}
		}
	}

	public static class BrushDownButtonHandler implements ActionListener {
		public void actionPerformed(ActionEvent e) {
			try {
				DataArray.brushSize--;
			} catch(Exception exc) {
				
			}
		}
	}
		
	public static class ExitButtonHandler implements ActionListener {
		public void actionPerformed(ActionEvent e) {
			System.exit(0);
		}
	}

	@Override
	public void mouseClicked(MouseEvent e) {		
		
	}

	@Override
	public void mouseEntered(MouseEvent e) {
			
	}

	@Override
	public void mouseExited(MouseEvent e) {
			
	}

	@Override
	public void mousePressed(final MouseEvent e) {

	}
	

	@Override
	public void mouseReleased(MouseEvent e) {

	}

	@Override
	public void mouseDragged(MouseEvent e) {
		if (heaterButtonActive) {
			DataArray.drawHeater(e.getX(),e.getY());
			g.validate();
			g.repaint();	
		} else if (insulatorButtonActive) {
			DataArray.drawInsulator(e.getX(),e.getY());
			g.validate();
			g.repaint();
		} else if (hotSpotButtonActive) {
			DataArray.drawHotSpot(e.getX(),e.getY());
			g.validate();
			g.repaint();
		}
	}
			

	public void mouseMoved(MouseEvent e) {
		if (heaterButtonActive) {
			DataArray.setRed(e.getX(),e.getY());
			g.validate();
			g.repaint();	
		} else if (insulatorButtonActive) {
			DataArray.setBlack(e.getX(),e.getY());
			g.validate();
			g.repaint();
		} else if (hotSpotButtonActive) {
			DataArray.setRed(e.getX(),e.getY());
			g.validate();
			g.repaint();
		}
	}
	
}
